/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the ExactOnlineDestinationAllOf type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExactOnlineDestinationAllOf{}

// ExactOnlineDestinationAllOf struct for ExactOnlineDestinationAllOf
type ExactOnlineDestinationAllOf struct {
	OAuthId    *int32         `json:"o_auth_id,omitempty"`
	DivisionId NullableString `json:"division_id,omitempty"`
	Endpoint   *string        `json:"endpoint,omitempty"`
}

// NewExactOnlineDestinationAllOf instantiates a new ExactOnlineDestinationAllOf object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExactOnlineDestinationAllOf() *ExactOnlineDestinationAllOf {
	this := ExactOnlineDestinationAllOf{}
	return &this
}

// NewExactOnlineDestinationAllOfWithDefaults instantiates a new ExactOnlineDestinationAllOf object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExactOnlineDestinationAllOfWithDefaults() *ExactOnlineDestinationAllOf {
	this := ExactOnlineDestinationAllOf{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *ExactOnlineDestinationAllOf) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExactOnlineDestinationAllOf) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *ExactOnlineDestinationAllOf) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *ExactOnlineDestinationAllOf) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetDivisionId returns the DivisionId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *ExactOnlineDestinationAllOf) GetDivisionId() string {
	if o == nil || IsNil(o.DivisionId.Get()) {
		var ret string
		return ret
	}
	return *o.DivisionId.Get()
}

// GetDivisionIdOk returns a tuple with the DivisionId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *ExactOnlineDestinationAllOf) GetDivisionIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.DivisionId.Get(), o.DivisionId.IsSet()
}

// HasDivisionId returns a boolean if a field has been set.
func (o *ExactOnlineDestinationAllOf) HasDivisionId() bool {
	if o != nil && o.DivisionId.IsSet() {
		return true
	}

	return false
}

// SetDivisionId gets a reference to the given NullableString and assigns it to the DivisionId field.
func (o *ExactOnlineDestinationAllOf) SetDivisionId(v string) {
	o.DivisionId.Set(&v)
}

// SetDivisionIdNil sets the value for DivisionId to be an explicit nil
func (o *ExactOnlineDestinationAllOf) SetDivisionIdNil() {
	o.DivisionId.Set(nil)
}

// UnsetDivisionId ensures that no value is present for DivisionId, not even an explicit nil
func (o *ExactOnlineDestinationAllOf) UnsetDivisionId() {
	o.DivisionId.Unset()
}

// GetEndpoint returns the Endpoint field value if set, zero value otherwise.
func (o *ExactOnlineDestinationAllOf) GetEndpoint() string {
	if o == nil || IsNil(o.Endpoint) {
		var ret string
		return ret
	}
	return *o.Endpoint
}

// GetEndpointOk returns a tuple with the Endpoint field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExactOnlineDestinationAllOf) GetEndpointOk() (*string, bool) {
	if o == nil || IsNil(o.Endpoint) {
		return nil, false
	}
	return o.Endpoint, true
}

// HasEndpoint returns a boolean if a field has been set.
func (o *ExactOnlineDestinationAllOf) HasEndpoint() bool {
	if o != nil && !IsNil(o.Endpoint) {
		return true
	}

	return false
}

// SetEndpoint gets a reference to the given string and assigns it to the Endpoint field.
func (o *ExactOnlineDestinationAllOf) SetEndpoint(v string) {
	o.Endpoint = &v
}

func (o ExactOnlineDestinationAllOf) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExactOnlineDestinationAllOf) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["o_auth_id"] = o.OAuthId
	}
	if o.DivisionId.IsSet() {
		toSerialize["division_id"] = o.DivisionId.Get()
	}
	if !IsNil(o.Endpoint) {
		toSerialize["endpoint"] = o.Endpoint
	}
	return toSerialize, nil
}

type NullableExactOnlineDestinationAllOf struct {
	value *ExactOnlineDestinationAllOf
	isSet bool
}

func (v NullableExactOnlineDestinationAllOf) Get() *ExactOnlineDestinationAllOf {
	return v.value
}

func (v *NullableExactOnlineDestinationAllOf) Set(val *ExactOnlineDestinationAllOf) {
	v.value = val
	v.isSet = true
}

func (v NullableExactOnlineDestinationAllOf) IsSet() bool {
	return v.isSet
}

func (v *NullableExactOnlineDestinationAllOf) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExactOnlineDestinationAllOf(val *ExactOnlineDestinationAllOf) *NullableExactOnlineDestinationAllOf {
	return &NullableExactOnlineDestinationAllOf{value: val, isSet: true}
}

func (v NullableExactOnlineDestinationAllOf) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExactOnlineDestinationAllOf) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
